#ifndef LOCAL
  #pragma GCC optimize("Ofast,unroll-loops")
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#ifndef LOCAL
  #pragma GCC target("avx,avx2,fma")
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define all(x) begin(x), end(x)
#define isz(x) (int)size(x)

void solve() {
  int n, m, T;
  cin >> n >> m >> T;
  vector<int> a(n);
  for (auto& it : a) {
    cin >> it;
  }
  vector<int> b(m);
  for (auto& it : b) {
    cin >> it;
  }
  vector<ll> p(n + 1);
  for (int i = 0; i < n; ++i) {
    p[i + 1] = p[i] + a[i];
  }
  vector<int> cnt(n);
  for (int i = 0; i < n; ++i) {
    for (int j = i; j >= 0; --j) {
      if (p[i + 1] - p[j + 1] > T) break;
      cnt[i] = max<ll>(cnt[i], (i - j) + (T - (p[i + 1] - p[j + 1])) / a[j]);

    }
    for (int j = i; j < n; ++j) {
      if (p[j] - p[i] > T) break;
      cnt[i] = max<ll>(cnt[i], (j - i) + (T - (p[j] - p[i])) / a[j]);
    }
  }
  int ans = 0;
  for (auto it : b) {
    ans = max(ans, cnt[it - 1]);
  }
  cout << ans << '\n';
}

signed main() {
  cin.tie(0)->sync_with_stdio(0);
  int t = 1;
  // cin >> t;
  for (int i = 0; i < t; ++i) {
    solve();
  }
}